
function Input(data) {
  let elem;
  const store = data.store;

  function construct() {
    elem = document.createElement('input');
    bind();
    update();
  }

  function update() {
    elem.value = store.getValue();
  }

  function enter() {}
  function exit() {}

  function destroy() {
    unbind();
  }

  function onInput() {
    store.setValue(elem.value);
  }

  function bind() {
    elem.addEventListener('input', onInput);
    store.on('value', update);
  }
  function unbind() {
    elem.removeEventListener('input', onInput);
    store.off('value', update);
  }

  construct();
  return { elem, data, update, enter, exit, destroy };
}
